/*
GooBer CPU core. 
Copyright (C) 2002 Ian Smith

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/* Cases for opcodes that are prefixed by 0xCB */


/* SWAP n -------------------------------------------------------------- */
#define P(S) printf(S);

case 0x37: A = (A >> 4) | (A << 4); F_SWAP(A); break; /* SWAP A */
case 0x30: B = (B >> 4) | (B << 4); F_SWAP(B); break; /* SWAP B */
case 0x31: C = (C >> 4) | (C << 4); F_SWAP(C); break; /* SWAP C */
case 0x32: D = (D >> 4) | (D << 4); F_SWAP(D); break; /* SWAP D */
case 0x33: E = (E >> 4) | (E << 4); F_SWAP(E); break; /* SWAP E */
case 0x34: H = (H >> 4) | (H << 4); F_SWAP(H); break; /* SWAP H */
case 0x35: L = (L >> 4) | (L << 4); F_SWAP(L); break; /* SWAP L */
case 0x36: WRITE_B(HL, ( (READ_B(HL) >> 4) | ( READ_B(HL) << 4) )); F_SWAP(READ_B(HL)); break; /* SWAP (HL) */

/* RLC n --------------------------------------------------------------- */
/* case 0x07: F_RLC(A); A = (A << 1) | (A >> 7); break; /\* RLC A *\/ */
/* case 0x00: F_RLC(B); B = (B << 1) | (B >> 7); break; /\* RLC B *\/ */
/* case 0x01: F_RLC(C); C = (C << 1) | (C >> 7); break; /\* RLC C *\/ */
/* case 0x02: F_RLC(D); D = (D << 1) | (D >> 7); break; /\* RLC D *\/ */
/* case 0x03: F_RLC(E); E = (E << 1) | (E >> 7); break; /\* RLC E *\/ */
/* case 0x04: F_RLC(H); H = (H << 1) | (H >> 7); break; /\* RLC H *\/ */
/* case 0x05: F_RLC(L); L = (L << 1) | (L >> 7); break; /\* RLC L *\/ */
/* case 0x06: F_RLC(READ_B(HL)); WRITE_B(HL, ( (READ_B(HL) << 1) | (READ_B(HL) >> 7) ) ); break; */
case 0x07: RLC(A); if (A == 0) ST(FZ); else CL(FZ); break;
case 0x00: RLC(B); if (B == 0) ST(FZ); else CL(FZ); break;
case 0x01: RLC(C); if (C == 0) ST(FZ); else CL(FZ); break;
case 0x02: RLC(D); if (D == 0) ST(FZ); else CL(FZ); break;
case 0x03: RLC(E); if (E == 0) ST(FZ); else CL(FZ); break;
case 0x04: RLC(H); if (H == 0) ST(FZ); else CL(FZ); break;
case 0x05: RLC(L); if (L == 0) ST(FZ); else CL(FZ); break;
case 0x06: 
lsb = READ_B(HL); RLC(lsb); WRITE_B(HL, lsb); 
if (lsb == 0) ST(FZ); else CL(FZ);
break;

/* RL n ---------------------------------------------------------------- */
/* case 0x17: F_RL(A); if (IS_SET(CARY_FLAG)) { A = (A << 1) | 0x01; }; break; */
/* case 0x10: F_RL(B); if (IS_SET(CARY_FLAG)) { B = (B << 1) | 0x01; }; break; */
/* case 0x11: F_RL(C); if (IS_SET(CARY_FLAG)) { C = (C << 1) | 0x01; }; break; */
/* case 0x12: F_RL(D); if (IS_SET(CARY_FLAG)) { D = (D << 1) | 0x01; }; break; */
/* case 0x13: F_RL(E); if (IS_SET(CARY_FLAG)) { E = (E << 1) | 0x01; }; break; */
/* case 0x14: F_RL(H); if (IS_SET(CARY_FLAG)) { H = (H << 1) | 0x01; }; break; */
/* case 0x15: F_RL(L); if (IS_SET(CARY_FLAG)) { L = (L << 1) | 0x01; }; break; */
/* case 0x16: F_RL(READ_B(HL)); if (IS_SET(CARY_FLAG)) { WRITE_B(HL, (READ_B(HL) << 1) | 0x01); }; break; */
case 0x17: RL(A); if (A == 0) ST(FZ); else CL(FZ); break;
case 0x10: RL(B); if (B == 0) ST(FZ); else CL(FZ); break;
case 0x11: RL(C); if (C == 0) ST(FZ); else CL(FZ); break;
case 0x12: RL(D); if (D == 0) ST(FZ); else CL(FZ); break;
case 0x13: RL(E); if (E == 0) ST(FZ); else CL(FZ); break;
case 0x14: RL(H); if (H == 0) ST(FZ); else CL(FZ); break;
case 0x15: RL(L); if (L == 0) ST(FZ); else CL(FZ); break;
case 0x16: 
lsb = READ_B(HL); RL(lsb); WRITE_B(HL, lsb); 
if (lsb == 0) ST(FZ); else CL(FZ);
break;

/* RRC n --------------------------------------------------------------- */
/* case 0x0F: F_RRC(A); A = (A >> 1) | (A << 7); break; */
/* case 0x08: F_RRC(B); B = (B >> 1) | (B << 7); break; */
/* case 0x09: F_RRC(C); C = (C >> 1) | (C << 7); break; */
/* case 0x0A: F_RRC(D); D = (D >> 1) | (D << 7); break; */
/* case 0x0B: F_RRC(E); E = (E >> 1) | (E << 7); break; */
/* case 0x0C: F_RRC(H); H = (H >> 1) | (H << 7); break; */
/* case 0x0D: F_RRC(L); L = (L >> 1) | (L << 7); break; */
/* case 0x0E: WRITE_B(HL, ((READ_B(HL) >> 1) | (READ_B(HL) << 7))); F_RRC(READ_B(HL)); break; /\* SWAP (HL) *\/ */
case 0x0F: RRC(A); if (A == 0) ST(FZ); else CL(FZ); break;
case 0x08: RRC(B); if (B == 0) ST(FZ); else CL(FZ); break;
case 0x09: RRC(C); if (C == 0) ST(FZ); else CL(FZ); break;
case 0x0A: RRC(D); if (D == 0) ST(FZ); else CL(FZ); break;
case 0x0B: RRC(E); if (E == 0) ST(FZ); else CL(FZ); break;
case 0x0C: RRC(H); if (H == 0) ST(FZ); else CL(FZ); break;
case 0x0D: RRC(L); if (L == 0) ST(FZ); else CL(FZ); break;
case 0x0E: 
lsb = READ_B(HL); RRC(lsb); WRITE_B(HL, lsb); 
if (lsb == 0) ST(FZ); else CL(FZ); break;

/* RR n ---------------------------------------------------------------- */
/* case 0x1F: F_RR(A); if (IS_SET(CARY_FLAG)) { A = (A >> 1) | 0x80; }; break; */
/* case 0x18: F_RR(B); if (IS_SET(CARY_FLAG)) { B = (B >> 1) | 0x80; }; break; */
/* case 0x19: F_RR(C); if (IS_SET(CARY_FLAG)) { C = (C >> 1) | 0x80; }; break; */
/* case 0x1A: F_RR(D); if (IS_SET(CARY_FLAG)) { D = (D >> 1) | 0x80; }; break; */
/* case 0x1B: F_RR(E); if (IS_SET(CARY_FLAG)) { E = (E >> 1) | 0x80; }; break; */
/* case 0x1C: F_RR(H); if (IS_SET(CARY_FLAG)) { H = (H >> 1) | 0x80; }; break; */
/* case 0x1D: F_RR(L); if (IS_SET(CARY_FLAG)) { L = (L >> 1) | 0x80; }; break; */
/* case 0x1E: F_RR(READ_B(HL)); if (IS_SET(CARY_FLAG)) { WRITE_B(HL, (READ_B(HL) >> 1) | 0x80); }; break; */

case 0x1F: RR(A); if (A == 0) ST(FZ); else CL(FZ); break;
case 0x18: RR(B); if (B == 0) ST(FZ); else CL(FZ); break;
case 0x19: RR(C); if (C == 0) ST(FZ); else CL(FZ); break;
case 0x1A: RR(D); if (D == 0) ST(FZ); else CL(FZ); break;
case 0x1B: RR(E); if (E == 0) ST(FZ); else CL(FZ); break;
case 0x1C: RR(H); if (H == 0) ST(FZ); else CL(FZ); break;
case 0x1D: RR(L); if (L == 0) ST(FZ); else CL(FZ); break;
case 0x1E: 
lsb = READ_B(HL); RR(lsb); WRITE_B(HL, lsb); break;
if (lsb == 0) ST(FZ); else CL(FZ); break;

/* SLA n --------------------------------------------------------------- */
/* case 0x27: A = A << 1; F_SLA(A); break; /\* SLA A *\/ */
/* case 0x20: B = B << 1; F_SLA(B); break; /\* SLA B *\/ */
/* case 0x21: C = C << 1; F_SLA(C); break; /\* SLA C *\/ */
/* case 0x22: D = D << 1; F_SLA(D); break; /\* SLA D *\/ */
/* case 0x23: E = E << 1; F_SLA(E); break; /\* SLA E *\/ */
/* case 0x24: H = H << 1; F_SLA(H); break; /\* SLA H *\/ */
/* case 0x25: L = L << 1; F_SLA(L); break; /\* SLA L *\/ */
/* case 0x26: WRITE_B(HL, (READ_B(HL) << 1)); F_SLA(READ_B(HL)); break; /\* SLA (HL) *\/ */
case 0x27: SLA(A); if (A == 0) ST(FZ); else CL(FZ); break;
case 0x20: SLA(B); if (B == 0) ST(FZ); else CL(FZ); break;
case 0x21: SLA(C); if (C == 0) ST(FZ); else CL(FZ); break;
case 0x22: SLA(D); if (D == 0) ST(FZ); else CL(FZ); break;
case 0x23: SLA(E); if (E == 0) ST(FZ); else CL(FZ); break;
case 0x24: SLA(H); if (H == 0) ST(FZ); else CL(FZ); break;
case 0x25: SLA(L); if (L == 0) ST(FZ); else CL(FZ); break;
case 0x26: 
lsb = READ_B(HL); SLA(lsb); WRITE_B(HL, lsb);
if (lsb == 0) ST(FZ); else CL(FZ); break;

/* SRA n --------------------------------------------------------------- */
/* case 0x2F: A = A >> 1; F_SRA(A); break; /\* SRA A *\/ */
/* case 0x28: B = B >> 1; F_SRA(B); break; /\* SRA B *\/ */
/* case 0x29: C = C >> 1; F_SRA(C); break; /\* SRA C *\/ */
/* case 0x2A: D = D >> 1; F_SRA(D); break; /\* SRA D *\/ */
/* case 0x2B: E = E >> 1; F_SRA(E); break; /\* SRA E *\/ */
/* case 0x2C: H = H >> 1; F_SRA(H); break; /\* SRA H *\/ */
/* case 0x2D: L = L >> 1; F_SRA(L); break; /\* SRA L *\/ */
/* case 0x2E: WRITE_B(HL, (READ_B(HL) >> 1)); F_SRA(READ_B(HL)); break; /\* SRA (HL) *\/ */
case 0x2F: SRA(A); break;
case 0x28: SRA(B); break;
case 0x29: SRA(C); break;
case 0x2A: SRA(D); break;
case 0x2B: SRA(E); break;
case 0x2C: SRA(H); break;
case 0x2D: SRA(L); break;
case 0x2E: lsb = READ_B(HL); SRA(lsb); WRITE_B(HL, lsb); break;

/* SRL n --------------------------------------------------------------- */
/* case 0x3F: A = (A >> 1) ^ (A & 0x80); F_SRL(A); break; /\* SRL A *\/ */
/* case 0x38: B = (B >> 1) ^ (B & 0x80); F_SRL(B); break; /\* SRL B *\/ */
/* case 0x39: C = (C >> 1) ^ (C & 0x80); F_SRL(C); break; /\* SRL C *\/ */
/* case 0x3A: D = (D >> 1) ^ (D & 0x80); F_SRL(D); break; /\* SRL D *\/ */
/* case 0x3B: E = (E >> 1) ^ (E & 0x80); F_SRL(E); break; /\* SRL E *\/ */
/* case 0x3C: H = (H >> 1) ^ (H & 0x80); F_SRL(H); break; /\* SRL H *\/ */
/* case 0x3D: L = (L >> 1) ^ (L & 0x80); F_SRL(L); break; /\* SRL L *\/ */
/* case 0x3E: WRITE_B(HL, ( (READ_B(HL) >> 1) ^ (READ_B(HL) & 0x80) ) ); F_SRL(READ_B(HL)); break; */
case 0x3F: SRL(A); if (A == 0) ST(FZ); else CL(FZ); break;
case 0x38: SRL(B); if (B == 0) ST(FZ); else CL(FZ); break;
case 0x39: SRL(C); if (C == 0) ST(FZ); else CL(FZ); break;
case 0x3A: SRL(D); if (D == 0) ST(FZ); else CL(FZ); break;
case 0x3B: SRL(E); if (E == 0) ST(FZ); else CL(FZ); break;
case 0x3C: SRL(H); if (H == 0) ST(FZ); else CL(FZ); break;
case 0x3D: SRL(L); if (L == 0) ST(FZ); else CL(FZ); break;
case 0x3E: 
lsb = READ_B(HL); SRL(lsb); WRITE_B(HL, lsb);
if (lsb == 0) ST(FZ); else CL(FZ); break;











