/*

Goober Portable Gameboy Emulator
Copyright (C) 2002 Ian Smith

This Program Is Free Software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#ifndef __INTR_H__
#define __INTR_H__

#define INTR_VBLANK   1
#define INTR_LCDSTAT  2
#define INTR_TIMER    4
#define INTR_SERIAL   8
#define INTR_JOYPAD   16

#include "gbcpu.h"

void intr_set_cpu(gbcpu_context *g);

/* IO Access functions */
unsigned char intr_read_reg(unsigned char reg);
void intr_write_reg(unsigned char reg, unsigned char value);

/* Request an interrupt */
void intr_request(unsigned char mask);

/* See if an interrupt is pending */
int intr_pending(unsigned char i);

#endif




