/*

Goober Portable Gameboy Emulator
Copyright (C) 2002 Ian Smith

This Program Is Free Software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#ifndef __JOYPAD_H__
#define __JOYPAD_H__

#include "allegro.h"

#define INPUT_LEFT  0
#define INPUT_RIGHT 1
#define INPUT_UP    2
#define INPUT_DOWN  3

#define START         4
#define SELECT        5
#define BUTTON_A      6
#define BUTTON_B      7

#define P15     32 /* select button keys */
#define P14     16 /* select direction keys */
#define P13     8 /* down/start */
#define P12     4 /* up/select */
#define P11     2 /* left/b */
#define P10     1 /* right/a */

void joypad_init();
void joypad_cleanup();

/* Read Keyboard buffer for pressed keys */
void joypad_update();

/* I/O access handlers */
unsigned char joypad_read_reg();
void joypad_write_reg(unsigned char value);

#endif








