/*
GooBer CPU core. 
Copyright (C) 2002 Ian Smith

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef __MFLAGS_H__
#define __MFLAGS_H__

#define F_INC(R) FLAGS = incflags[(u8)(R+1)]
/* #define F_INC(R) \ */
/* TGL((R+1==0), FZ); TGL( (((R+1)&0x0F)>0x0F), FH); CL(FN) */

#define F_DEC(R) FLAGS = decflags[(R-1)]
/* #define F_DEC(R) \ */
/* TGL((R-1==0), FZ); TGL( (((R-1)&0x0F)<0), FH); ST(FN) */


/*
#define F_ADD_HL(DEST, SRC) \
CL(FN); \
TGL(( ((DEST&0x00FF) + (SRC&0x00FF)) > 0xFF), FH); \
TGL(((DEST+SRC)>0xFFFF), FC)
*/

#define F_ADD_HL(DEST, SRC) { \
CL(FN); \
if ((DEST + SRC) > 0xFFFF) \
  ST(FC); \
else \
  CL(FC); \
}

#define F_ADD(S) { \
CL(FN); TGL((A+S==0), FZ); \
if ((A & 0x0F) + (S & 0x0F) > 0x0F) \
  ST(FH); \
else \
  CL(FH); \
if (A + S > 0xFF) \
  ST(FC); \
else \
 CL(FC); \
}

/*
#define F_ADD_SP(DEST, SRC) \
CL(FZ); CL(FN); CL(FH); \
TGL(((DEST+SRC)>0xFFFF), FC)
*/

#define F_ADD_SP(DEST, R) \
CL(FN); ST(FC); \
TGL((((DEST&0x00FF)+R)>0xFF), FH); \
TGL(((DEST+R)==0), FZ)

#define F_ADC(S) F_ADD(S + ((FLAGS & FC) >> 4))

/* #define F_ADC(S) { \ */
/* CL(FN); \ */
/* lsb = (FLAGS&FC)>>4; \ */
/* if ((A&0x0F) + (S&0x0F) + ((FLAGS&FC)>>4) > 0x0F) ST(FH); else CL(FH); \ */
/* if (A + S + lsb > 0xFF) ST(FC); else CL(FC); \ */
/* if (A + S + lsb == 0) ST(FZ); else CL(FZ); \ */
/* } */

#define F_SUB(DEST, SRC) \
TGL(((DEST-SRC)==0), FZ); ST(FN); \
TGL(((DEST&0x0F) - (SRC&0x0F) < 0), FH) \
TGL((DEST<SRC), FC)

#define F_SBC(DEST, SRC) \
TGL(((DEST-SRC-CF)==0), FZ); ST(FN); \
TGL(((DEST&0x0F) - (SRC&0x0F) < 0), FH) \
TGL(((DEST-SRC-CF)<0), FC)

#define F_AND(DEST, SRC) \
TGL(((DEST & SRC)==0), FZ); CL(FN); ST(FH); CL(FC)

#define F_OR(DEST, SRC) \
TGL(((DEST | SRC)==0), FZ); CL(FN); CL(FH); CL(FC)

#define F_XOR(DEST, SRC) \
TGL(((DEST ^ SRC)==0), FZ); CL(FN); CL(FH); CL(FC)

#define F_CP(DEST, SRC) \
TGL((DEST==SRC), FZ); ST(FN); \
TGL(((DEST&0x0F) < (SRC&0x0F)), FH) \
TGL(((DEST-SRC)<0), FC)

#define F_SWAP(RESULT) \
TGL((RESULT==0), FZ); \
CL(FN); CL(FH); CL(FC)

#define F_DAA(RESULT) \
TGL((RESULT==0), FZ); CL(FH)

#define F_CPL() ST(FN); ST(FH);

#define F_CCF() CL(FN); CL(FH); if ((FLAGS&FC)==FC) CL(FC); else ST(FC)

#define F_SCF() CL(FN); CL(FH); ST(FC)

#define F_RLCA() \
CL(FZ); CL(FN); CL(FH);\
TGL(((A & 0x80) == 0x80), FC)

#define F_RRCA() \
CL(FZ); CL(FN); CL(FH);\
TGL(((A & 0x01) == 0x01), FC)

#define F_RLC(RESULT) \
CL(FZ); CL(FN); CL(FH);\
TGL(((RESULT & 0x80) == 0x80), FC)

#define F_RRC(RESULT) \
CL(FZ); CL(FN); CL(FH);\
TGL(((RESULT & 0x01) == 0x01), FC)

#define F_RL(RESULT) \
TGL((RESULT==0), FZ); CL(FN); CL(FH); \
TGL(((RESULT & 0x80) == 0x80), FC)

#define F_RR(RESULT) \
TGL((RESULT==0), FZ); CL(FN); CL(FH); \
TGL(((RESULT & 0x01) == 0x01), FC)

#define F_SLA(RESULT) \
TGL(((RESULT & 0x7F) == 0), FZ); \
CL(FN); CL(FH); \
TGL(((RESULT & 0x80) == 0x80), FC)

#define F_SRA(RESULT) \
TGL((RESULT == 0), FZ); \
CL(FN); CL(FH); \
TGL(((RESULT & 0x01) == 0x01), FC)

#define F_SRL(RESULT) \
TGL(((RESULT & 0xFE)==0), FZ); \
CL(FN); CL(FH); \
TGL(((RESULT & 0x01) == 0x01), FC)


#define F_BIT(RESULT, BIT) \
TGL(((RESULT * bits[BIT]) == bits[BIT]), FZ); \
CL(FN); ST(FH)

#define BIT(b, r) { \
if ((r & bits[b]) == 0) \
  ST(FZ); \
else \
  CL(FZ); \
CL(FN); \
ST(FH); \
}

#define SET(b, r) r = r | bits[b]
#define RES(b, r) r ^= ( (r&bits[b])==bits[b] ? bits[b] : 0 );

#define INC(r) \
{ \
CL(FN); \
r++; \
FLAGS = (FLAGS&FC)|incflags[(u8)r]; \
}

#define DEC(r) \
{ \
r--; \
FLAGS = (FLAGS&FC)|decflags[(u8)r]; \
}

#define ADD(r) \
{ \
if (A + r > 0xFF) ST(FC); else CL(FC); \
if ( (A & 0x0F) + (r & 0x0F) > 0x0F ) ST(FH); else CL(FH); \
A = A + r; \
if (A == 0) ST(FZ); else CL(FZ); \
CL(FN); \
}

#define ADDHL(r) \
{ \
CL(FN); \
if ( HL + r > 0xFFFF ) ST(FC); else CL(FC); \
set_HL(HL+r); \
if ( HL == 0 ) ST(FZ); else CL(FZ); \
}

#define ADDSP(r) \
{ \
CL(FZ); CL(FN); CL(FH); \
if ((u16)( (i16)SP + (i8)r ) > 0xFFFF) ST(FC); else CL(FC); \
SP = (u16)( (i16)SP + (i8)r ); \
}

#define ADC(r) \
{ \
CL(FN); \
lsb = (FLAGS&FC)>>4; \
if (A + r + lsb == 0) ST(FZ); else CL(FZ); \
if (A + r + lsb > 0xFF) ST(FC); else CL(FC); \
if ((A & 0x0F) + (r & 0x0F) + lsb > 0x0F) ST(FH); else CL(FH); \
A = A + r + lsb; \
if (A == 0) ST(FZ); else CL(FZ); \
}

#define SUB(r) \
{ \
ST(FN); \
if (A - r < 0) ST(FC); else CL(FC); \
if ((A & 0x0F) - (r & 0x0F) < 0) ST(FH); else CL(FH); \
A = A - r; \
if (A == 0) ST(FZ); else CL(FZ); \
}

#define SBC(r) \
{ \
ST(FN); \
lsb = (FLAGS&FC)>>4; \
if (A - r - lsb == 0) ST(FZ); else CL(FZ); \
if (A - r - lsb < 0)  ST(FC); else CL(FC); \
if ((A & 0x0F) < ((r-lsb) & 0x0F)) ST(FH); else CL(FH); \
A = A - r - lsb; \
}

#define CP(r) \
{ \
ST(FN); \
if (A == r) ST(FZ); else CL(FZ); \
if (A < r) ST(FC); else CL(FC); \
}

#define RL(r) \
{ \
CL(FH); CL(FN); \
lsb = FLAGS; \
if ((r&0x80)==0x80) ST(FC); else CL(FC); \
r = (r << 1)|((lsb&FC)>>4); \
}

#define RLC(r) \
{ \
CL(FH); CL(FN); \
if ((r&0x80)==0x80) ST(FC); else CL(FC); \
r = (r << 1) | (r >> 7); \
}

#define RR(r) \
{ \
CL(FH); CL(FN); \
lsb = FLAGS; \
if ((r&1)==1) ST(FC); else CL(FC); \
r = (r >> 1) | ((lsb&FC) << 3); \
}

#define RRC(r) \
{ \
CL(FH); CL(FN); \
if ((r&1)==1) ST(FC); else CL(FC); \
r = (r >> 1) | (r << 7); \
}

#define SLA(r) \
{ \
CL(FH); CL(FN); \
if ((r&0x80)==0x80) ST(FC); else CL(FC); \
r = r << 1; \
if (r == 0) ST(FZ); else CL(FZ); \
}

#define SRA(r) \
{ \
CL(FH); CL(FN); \
if ((r&1)==1) ST(FC); else CL(FC); \
r = (r&0x80) | (r >> 1); \
if (r == 0) ST(FZ); else CL(FZ); \
}

#define SRL(r) \
{ \
CL(FH); CL(FN); \
if ((r&1)==1) ST(FC); else CL(FC); \
r = r >> 1; \
if (r == 0) ST(FZ); else CL(FZ); \
}

#endif
