/*
GooBer CPU core. 
Copyright (C) 2002 Ian Smith

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/* LD r, n  -------------------------------------------------------------- */
case 0x06: B = READ_B(PC++); break; /* LD B, n */
case 0x0E: C = READ_B(PC++); break; /* LD C, n */
case 0x16: D = READ_B(PC++); break; /* LD D, n */
case 0x1E: E = READ_B(PC++); break; /* LD E, n */
case 0x26: H = READ_B(PC++); break; /* LD H, n */
case 0x2E: L = READ_B(PC++); break; /* LD L, n */

/* LD r1, r2  ----------------------------------------------------------- */
case 0x78: A = B; break; /* LD A, B */
case 0x79: A = C; break; /* LD A, C */
case 0x7A: A = D; break; /* LD A, D */
case 0x7B: A = E; break; /* LD A, E */
case 0x7C: A = H; break; /* LD A, H */
case 0x7D: A = L; break; /* LD A, L */
case 0x7E: A = READ_B(HL); break; /* LD A, (HL) */

case 0x40: B = B; break; /* LD B, B */
case 0x41: B = C; break; /* LD B, C */
case 0x42: B = D; break; /* LD B, D */
case 0x43: B = E; break; /* LD B, E */
case 0x44: B = H; break; /* LD B, H */
case 0x45: B = L; break; /* LD B, L */
case 0x46: B = READ_B(HL); break; /* LD B, (HL) */

case 0x48: C = B; break; /* LD C, B */
case 0x49: C = C; break; /* LD C, C */
case 0x4A: C = D; break; /* LD C, D */
case 0x4B: C = E; break; /* LD C, E */
case 0x4C: C = H; break; /* LD C, H */
case 0x4D: C = L; break; /* LD C, L */
case 0x4E: C = READ_B(HL); break; /* LD C, (HL) */

case 0x50: D = B; break; /* LD D, B */
case 0x51: D = C; break; /* LD D, C */
case 0x52: D = D; break; /* LD D, D */
case 0x53: D = E; break; /* LD D, E */
case 0x54: D = H; break; /* LD D, H */
case 0x55: D = L; break; /* LD D, L */
case 0x56: D = READ_B(HL); break; /* LD D, (HL) */

case 0x58: E = B; break; /* LD E, B */
case 0x59: E = C; break; /* LD E, C */
case 0x5A: E = D; break; /* LD E, D */
case 0x5B: E = E; break; /* LD E, E */
case 0x5C: E = H; break; /* LD E, H */
case 0x5D: E = L; break; /* LD E, L */
case 0x5E: E = READ_B(HL); break; /* LD E, (HL) */

case 0x60: H = B; break; /* LD H, B */
case 0x61: H = C; break; /* LD H, C */
case 0x62: H = D; break; /* LD H, D */
case 0x63: H = E; break; /* LD H, E */
case 0x64: H = H; break; /* LD H, H */
case 0x65: H = L; break; /* LD H, L */
case 0x66: H = READ_B(HL); break; /* LD H, (HL) */

case 0x68: L = B; break; /* LD L, B */
case 0x69: L = C; break; /* LD L, C */
case 0x6A: L = D; break; /* LD L, D */
case 0x6B: L = E; break; /* LD L, E */
case 0x6C: L = H; break; /* LD L, H */
case 0x6D: L = L; break; /* LD L, L */
case 0x6E: L = READ_B(HL); break; /* LD L, (HL) */

case 0x70: WRITE_B(HL, B); break; /* LD (HL), B */
case 0x71: WRITE_B(HL, C); break; /* LD (HL), C */
case 0x72: WRITE_B(HL, D); break; /* LD (HL), D */
case 0x73: WRITE_B(HL, E); break; /* LD (HL), E */
case 0x74: WRITE_B(HL, H); break; /* LD (HL), H */
case 0x75: WRITE_B(HL, L); break; /* LD (HL), L */
case 0x36: WRITE_B(HL, READ_B(PC++)); break; /* LD (HL), n */

/* LD A, n ------------------------------------------------------------- */
case 0x7F: A = A; break; /* LD A, A */
case 0x0A: A = READ_B(BC); break; /* LD A, (BC) */
case 0x1A: A = READ_B(DE); break; /* LD A, (DE) */
case 0x3E: A = READ_B(PC++); break; /* LD A, n */
case 0xFA: A = READ_B(READ_W(PC)); PC+=2; break; /* LD A, (nn) */

/* LD n, A ------------------------------------------------------------- */
case 0x47: B = A; break; /* LD B, A */
case 0x4F: C = A; break; /* LD C, A */
case 0x57: D = A; break; /* LD D, A */
case 0x5F: E = A; break; /* LD E, A */
case 0x67: H = A; break; /* LD H, A */
case 0x6F: L = A; break; /* LD L, A */
case 0x02: WRITE_B(BC, A); break; /* LD (BC), A */
case 0x12: WRITE_B(DE, A); break; /* LD (DE), A */
case 0x77: WRITE_B(HL, A); break; /* LD (HL), A */
case 0xEA: WRITE_B(READ_W(PC), A); PC+=2; break; /* LD (nn), A */

/* LD A, (C) ------------------------------------------------------------ */
case 0xF2: A = READ_B((0xFF00 + C)); break;

/* LD (C), A ------------------------------------------------------------ */
case 0xE2: WRITE_B((0xFF00 + C), A); break;

/* LDD A, (HL) ---------------------------------------------------------- */
case 0x3A: A = READ_B(HL); set_HL(HL-1); break;

/* LDD (HL), A ---------------------------------------------------------- */
case 0x32: WRITE_B(HL, A); set_HL(HL-1); break;

/* LDI A, (HL) ---------------------------------------------------------- */
case 0x2A: A = READ_B(HL); set_HL(HL+1); break;

/* LDI (HL), A ---------------------------------------------------------- */
case 0x22: WRITE_B(HL, A); set_HL(HL+1); break;

/* LDH (FF00+n), A ------------------------------------------------------ */
case 0xE0: WRITE_B(0xFF00 + READ_B(PC++), A); break;

/* LDH A, (FF00+n) ------------------------------------------------------ */
case 0xF0: A = READ_B(0xFF00 + READ_B(PC++)); break;

/* LD n, nn ------------------------------------------------------------- */
case 0x01: set_BC(READ_W(PC)); PC+=2; break;     /* LD BC, nn */
case 0x11: set_DE(READ_W(PC)); PC+=2; break;     /* LD DE, nn */
case 0x21: set_HL(READ_W(PC)); PC+=2; break;     /* LD HL, nn */
case 0x31: SP = READ_W(PC); PC+=2; break; /* LD SP, nn */
case 0xF9: SP = HL; break;                          /* LD SP, HL */

/* LDHL SP, n ----------------------------------------------------------- */
case 0xF8: set_HL(SP + (signed char)READ_B(PC)); PC++; CL(FZ); CL(FN); break;

/* LD (nn), SP ---------------------------------------------------------- */
case 0x08: WRITE_W(READ_W(PC), SP); PC+=2; break;

/* PUSH nn -------------------------------------------------------------- */
case 0xF5: PUSH_B(A); PUSH_B(gbcpu->flags); break; /* PUSH AF */
case 0xC5: PUSH_B(B); PUSH_B(C); break; /* PUSH BC */
case 0xD5: PUSH_B(D); PUSH_B(E); break; /* PUSH DE */
case 0xE5: PUSH_B(H); PUSH_B(L); break; /* PUSH HL */

/* POP nn -------------------------------------------------------------- */
case 0xF1: gbcpu->flags = POP_B(); A = POP_B(); break; /* POP AF */
case 0xC1: C = POP_B(); B = POP_B(); break; /* POP BC */
case 0xD1: E = POP_B(); D = POP_B(); break; /* POP DE */
case 0xE1: L = POP_B(); H = POP_B(); break; /* POP HL */

/* ADD A, n ------------------------------------------------------------ */
/* case 0x87: F_ADD(A); A += A; break; /\* ADD A, A *\/ */
/* case 0x80: F_ADD(B); A += B; break; /\* ADD A, B *\/ */
/* case 0x81: F_ADD(C); A += C; break; /\* ADD A, C *\/ */
/* case 0x82: F_ADD(D); A += D; break; /\* ADD A, D *\/ */
/* case 0x83: F_ADD(E); A += E; break; /\* ADD A, E *\/ */
/* case 0x84: F_ADD(H); A += H; break; /\* ADD A, H *\/ */
/* case 0x85: F_ADD(L); A += L; break; /\* ADD A, L *\/ */
/* case 0x86: F_ADD(READ_B(HL)); A += READ_B(HL); break; /\* ADD A, (HL) *\/ */
/* case 0xC6: F_ADD(READ_B(PC)); A += READ_B(PC); PC++; break; /\* ADD A, # *\/ */

case 0x87: ADD(A); break; /* ADD A */
case 0x80: ADD(B); break; /* ADD B */
case 0x81: ADD(C); break; /* ADD C */
case 0x82: ADD(D); break; /* ADD D */
case 0x83: ADD(E); break; /* ADD E */
case 0x84: ADD(H); break; /* ADD H */
case 0x85: ADD(L); break; /* ADD L */
case 0x86: ADD(READ_B(HL)); break; /* ADD (HL) */
case 0xC6: ADD(READ_B(PC)); PC++; break; /* ADD # */

/* ADC A, n ------------------------------------------------------------ */
/* case 0x8F: F_ADC(A); A += A + ((FLAGS&FC)>>4); break; /\* ADC A, A *\/ */
/* case 0x88: F_ADC(B); A += B + ((FLAGS&FC)>>4); break; /\* ADC A, B *\/ */
/* case 0x89: F_ADC(C); A += C + ((FLAGS&FC)>>4); break; /\* ADC A, C *\/ */
/* case 0x8A: F_ADC(D); A += D + ((FLAGS&FC)>>4); break; /\* ADC A, D *\/ */
/* case 0x8B: F_ADC(E); A += E + ((FLAGS&FC)>>4); break; /\* ADC A, E *\/ */
/* case 0x8C: F_ADC(H); A += H + ((FLAGS&FC)>>4); break; /\* ADC A, H *\/ */
/* case 0x8D: F_ADC(L); A += L + ((FLAGS&FC)>>4); break; /\* ADC A, L *\/ */
/* case 0x8E: F_ADC(READ_B(HL)); A += READ_B(HL) + ((FLAGS&FC)>>4); break; /\* ADC A, (HL) *\/ */
/* case 0xCE: F_ADC(READ_B(PC)); A += READ_B(PC) + ((FLAGS&FC)>>4); PC++; break; /\* ADC A, # *\/ */

case 0x8F: ADC(A); break; /* ADC A */
case 0x88: ADC(B); break; /* ADC B */
case 0x89: ADC(C); break; /* ADC C */
case 0x8A: ADC(D); break; /* ADC D */
case 0x8B: ADC(E); break; /* ADC E */
case 0x8C: ADC(H); break; /* ADC H */
case 0x8D: ADC(L); break; /* ADC L */
case 0x8E: ADC(READ_B(HL)); break;
case 0xCE: ADC(READ_B(PC)); PC++; break;

/* SUB A, n ------------------------------------------------------------ */
/* case 0x97: F_SUB(A, A); A -= A; break; /\* SUB A *\/ */
/* case 0x90: F_SUB(A, B); A -= B; break; /\* SUB B *\/ */
/* case 0x91: F_SUB(A, C); A -= C; break; /\* SUB C *\/ */
/* case 0x92: F_SUB(A, D); A -= D; break; /\* SUB D *\/ */
/* case 0x93: F_SUB(A, E); A -= E; break; /\* SUB E *\/ */
/* case 0x94: F_SUB(A, H); A -= H; break; /\* SUB H *\/ */
/* case 0x95: F_SUB(A, L); A -= L; break; /\* SUB L *\/ */
/* case 0x96: F_SUB(A, READ_B(HL)); A -= READ_B(HL); break; /\* SUB (HL) *\/ */
/* case 0xD6: F_SUB(A, READ_B(PC)); A -= READ_B(PC); PC++; break; /\* SUB # *\/ */

case 0x97: SUB(A); break; /* SUB A */
case 0x90: SUB(B); break; /* SUB B */
case 0x91: SUB(C); break; /* SUB C */
case 0x92: SUB(D); break; /* SUB D */
case 0x93: SUB(E); break; /* SUB E */
case 0x94: SUB(H); break; /* SUB H */
case 0x95: SUB(L); break; /* SUB L */
case 0x96: SUB(READ_B(HL)); break; /* SUB (HL) */
case 0xD6: SUB(READ_B(PC)); PC++; break; /* SUB # */

/* SBC A, n ------------------------------------------------------------ */
/* case 0x9F: F_SBC(A, A); A = A-A-CF; break; /\* SBC A *\/ */
/* case 0x98: F_SBC(A, B); A = A-B-CF; break; /\* SBC B *\/ */
/* case 0x99: F_SBC(A, C); A = A-C-CF; break; /\* SBC C *\/ */
/* case 0x9A: F_SBC(A, D); A = A-D-CF; break; /\* SBC D *\/ */
/* case 0x9B: F_SBC(A, E); A = A-E-CF; break; /\* SBC E *\/ */
/* case 0x9C: F_SBC(A, H); A = A-H-CF; break; /\* SBC H *\/ */
/* case 0x9D: F_SBC(A, L); A = A-L-CF; break; /\* SBC L *\/ */
/* case 0x9E: F_SBC(A, (READ_B(HL))); A = A-READ_B(HL)-CF; break; /\* SBC (HL) *\/ */
/* case 0xDE: F_SBC(A, (READ_B(PC))); A = A-READ_B(PC)-CF; PC++; break; /\* SBC # *\/ */

case 0x9F: SBC(A); break; /* SBC A */
case 0x98: SBC(B); break; /* SBC B */
case 0x99: SBC(C); break; /* SBC C */
case 0x9A: SBC(D); break; /* SBC D */
case 0x9B: SBC(E); break; /* SBC E */
case 0x9C: SBC(H); break; /* SBC H */
case 0x9D: SBC(L); break; /* SBC L */
case 0x9E: SBC(READ_B(HL)); break; /* SBC (HL) */
case 0xDE: SBC(READ_B(PC)); PC++; break; /* SBC # */

/* AND n --------------------------------------------------------------- */
case 0xA7: F_AND(A, A); A = A & A; break; /* AND A */
case 0xA0: F_AND(A, B); A = A & B; break; /* AND B */
case 0xA1: F_AND(A, C); A = A & C; break; /* AND C */
case 0xA2: F_AND(A, D); A = A & D; break; /* AND D */
case 0xA3: F_AND(A, E); A = A & E; break; /* AND E */
case 0xA4: F_AND(A, H); A = A & H; break; /* AND H */
case 0xA5: F_AND(A, L); A = A & L; break; /* AND L */
case 0xA6: F_AND(A, READ_B(HL)); A = A & READ_B(HL); break; /* AND (HL) */
case 0xE6: F_AND(A, READ_B(PC)); A = A & READ_B(PC); PC++; break; /* AND # */

/* OR n ---------------------------------------------------------------- */
case 0xB7: F_OR(A, A); A = A | A; break; /* OR A */
case 0xB0: F_OR(A, B); A = A | B; break; /* OR B */
case 0xB1: F_OR(A, C); A = A | C; break; /* OR C */
case 0xB2: F_OR(A, D); A = A | D; break; /* OR D */
case 0xB3: F_OR(A, E); A = A | E; break; /* OR E */
case 0xB4: F_OR(A, H); A = A | H; break; /* OR H */
case 0xB5: F_OR(A, L); A = A | L; break; /* OR L */
case 0xB6: F_OR(A, READ_B(HL)); A = A | READ_B(HL); break; /* OR (HL) */
case 0xF6: F_OR(A, READ_B(PC)); A = A | READ_B(PC); PC++; break; /* OR # */

/* XOR n ---------------------------------------------------------------- */
case 0xAF: F_XOR(A, A); A = A ^ A; break; /* XOR A */
case 0xA8: F_XOR(A, B); A = A ^ B; break; /* XOR B */
case 0xA9: F_XOR(A, C); A = A ^ C; break; /* XOR C */
case 0xAA: F_XOR(A, D); A = A ^ D; break; /* XOR D */
case 0xAB: F_XOR(A, E); A = A ^ E; break; /* XOR E */
case 0xAC: F_XOR(A, H); A = A ^ H; break; /* XOR H */
case 0xAD: F_XOR(A, L); A = A ^ L; break; /* XOR L */
case 0xAE: F_XOR(A, READ_B(HL)); A = A ^ READ_B(HL); break; /* XOR (HL) */
case 0xEE: F_XOR(A, READ_B(PC)); A = A ^ READ_B(PC); PC++; break; /* XOR # */

/* CP n ---------------------------------------------------------------- */
/* case 0xBF: F_CP(A, B); break; /\* CP A *\/ */
/* case 0xB8: F_CP(A, B); break; /\* CP B *\/ */
/* case 0xB9: F_CP(A, B); break; /\* CP C *\/ */
/* case 0xBA: F_CP(A, B); break; /\* CP D *\/ */
/* case 0xBB: F_CP(A, B); break; /\* CP E *\/ */
/* case 0xBC: F_CP(A, B); break; /\* CP H *\/ */
/* case 0xBD: F_CP(A, B); break; /\* CP L *\/ */
/* case 0xBE: F_CP(A, READ_B(HL)); break; /\* CP (HL) *\/ */
/* case 0xFE: F_CP(A, READ_B(PC)); PC++; break; /\* CP # *\/ */

case 0xBF: CP(A); break; /* CP A */
case 0xB8: CP(B); break; /* CP B */
case 0xB9: CP(C); break; /* CP C */
case 0xBA: CP(D); break; /* CP D */
case 0xBB: CP(E); break; /* CP E */
case 0xBC: CP(H); break; /* CP H */
case 0xBD: CP(L); break; /* CP L */
case 0xBE: CP(READ_B(HL)); break; /* CP (HL) */
case 0xFE: CP(READ_B(PC)); PC++; break; /* CP # */

/* INC n --------------------------------------------------------------- */
case 0x3C: INC(A); break; /* INC A */
case 0x04: INC(B); break; /* INC B */
case 0x0C: INC(C); break; /* INC C */
case 0x14: INC(D); break; /* INC D */
case 0x1C: INC(E); break; /* INC E */
case 0x24: INC(H); break; /* INC H */
case 0x2C: INC(L); break; /* INC L */
case 0x34: lsb = READ_B(HL); INC(lsb); WRITE_B(HL, lsb); break; /* INC (HL) */

/* case 0x3C: F_INC(A); A+=1; break; /\* INC A *\/ */
/* case 0x04: F_INC(B); B+=1; break; /\* INC B *\/ */
/* case 0x0C: F_INC(C); C+=1; break; /\* INC C *\/ */
/* case 0x14: F_INC(D); D+=1; break; /\* INC D *\/ */
/* case 0x1C: F_INC(E); E+=1; break; /\* INC E *\/ */
/* case 0x24: F_INC(H); H+=1; break; /\* INC H *\/ */
/* case 0x2C: F_INC(L); L+=1; break; /\* INC L *\/ */
/* case 0x34: lsb = READ_B(HL); F_INC(lsb); lsb+=1; WRITE_B(HL, lsb); break; /\* INC (HL) *\/ */

/* DEC n --------------------------------------------------------------- */
case 0x3D: DEC(A); break; /* DEC A */
case 0x05: DEC(B); break; /* DEC B */
case 0x0D: DEC(C); break; /* DEC C */
case 0x15: DEC(D); break; /* DEC D */
case 0x1D: DEC(E); break; /* DEC E */
case 0x25: DEC(H); break; /* DEC H */
case 0x2D: DEC(L); break; /* DEC L */
case 0x35: lsb = READ_B(HL); DEC(lsb); WRITE_B(HL, lsb); break; /* DEC (HL) */

/* case 0x3D: F_DEC(A); A-=1; break; /\* DEC A *\/ */
/* case 0x05: F_DEC(B); B-=1; break; /\* DEC B *\/ */
/* case 0x0D: F_DEC(C); C-=1; break; /\* DEC C *\/ */
/* case 0x15: F_DEC(D); D-=1; break; /\* DEC D *\/ */
/* case 0x1D: F_DEC(E); E-=1; break; /\* DEC E *\/ */
/* case 0x25: F_DEC(H); H-=1; break; /\* DEC H *\/ */
/* case 0x2D: F_DEC(L); L-=1; break; /\* DEC L *\/ */
/* case 0x35: lsb = READ_B(HL); F_DEC(lsb); lsb-=1; WRITE_B(HL, lsb); break; /\* DEC (HL) *\/ */

/* ADD HL, n ----------------------------------------------------------- */
/* case 0x09: F_ADD_HL(HL, BC); set_HL((HL + BC)); break; /\* ADD HL, BC *\/ */
/* case 0x19: F_ADD_HL(HL, DE); set_HL((HL + DE)); break; /\* ADD HL, DE *\/ */
/* case 0x29: F_ADD_HL(HL, HL); set_HL((HL + HL)); break; /\* ADD HL, HL *\/ */
/* case 0x39: F_ADD_HL(HL, SP); set_HL((HL + SP)); break; /\* ADD HL, SP *\/ */

case 0x09: ADDHL(BC); break; /* ADD HL, BC */
case 0x19: ADDHL(DE); break; /* ADD HL, BC */
case 0x29: ADDHL(HL); break; /* ADD HL, BC */
case 0x39: ADDHL(SP); break; /* ADD HL, BC */

/* ADD SP, n ----------------------------------------------------------- */
//case 0xE8: SP = (unsigned short)( (signed short)SP + (char)READ_B(PC) ); PC++; break;
/* case 0xE8:  */
/*   F_ADD_SP(SP, READ_B(PC)); */
/*   SP = (unsigned short)( (signed short)SP + (char)READ_B(PC) ); */
/*   PC++;  */
/*   break; */

case 0xE8: ADDSP(READ_B(PC)); PC++; break;

/* INC nn -------------------------------------------------------------- */
case 0x03: set_BC(BC+1); break; /* INC BC */
case 0x13: set_DE(DE+1); break; /* INC DE */
case 0x23: set_HL(HL+1); break; /* INC HL */
case 0x33: SP = SP+1; break; /* INC SP */

/* DEC nn -------------------------------------------------------------- */
case 0x0B: set_BC(BC-1); break; /* DEC BC */
case 0x1B: set_DE(DE-1); break; /* DEC DE */
case 0x2B: set_HL(HL-1); break; /* DEC HL */
case 0x3B: SP = SP-1; break; /* DEC SP */

/* DAA ----------------------------------------------------------------- */
case 0x27: F_DAA(A); /* DAA .. i don't know how to implement this! */

/* CPL A --------------------------------------------------------------- */
case 0x2F: A = ~A; F_CPL(); break;

/* CCF ----------------------------------------------------------------- */
case 0x3F: FLAGS ^= FC; break;

/* SCF ----------------------------------------------------------------- */
case 0x37: F_SCF(); break;

/* NOP ----------------------------------------------------------------- */
case 0x00: break;

/* HALT ---------------------------------------------------------------- */
case 0x76: gbcpu->cpu_mode = CPU_HALT; break;

/* DI ------------------------------------------------------------------ */
case 0xF3: gbcpu->ime = 0; break;

/* EI ------------------------------------------------------------------ */
case 0xFB: gbcpu->ime = 1; break;

/* RLCA ---------------------------------------------------------------- */
/* case 0x07: F_RLCA(); A = (A << 1) | (A >> 7); break; */
case 0x07: RLC(A); CL(FZ); break;

/* RLA ---------------------------------------------------------------- */
//case 0x17: TGL((A&0x80), FC); A = (A << 1) | ((FLAGS&FC) >> 4); break;
/* case 0x17: FLAGS |= ((A&0x01)<<4); A = (A << 1) | ((FLAGS&FC)>>4); break; */
case 0x17: RL(A); CL(FZ); break;

/* RRCA ---------------------------------------------------------------- */
/* case 0x0F: F_RRCA(); A = (A >> 1) | (A << 7); break; */
case 0x0F: RRC(A); CL(FZ); break;

/* RRA ---------------------------------------------------------------- */
/* case 0x1F: A = (A >> 1) | (A << 7); break; */
case 0x1F: RR(A); CL(FZ); break;

/* JP nn -------------------------------------------------------------- */
case 0xC3: PC = READ_W(PC); break;

/* JP cc, nn ---------------------------------------------------------- */
case 0xC2: addr = READ_W(PC); PC+=2; if (!ZF) { PC = addr; } break;
case 0xCA: addr = READ_W(PC); PC+=2; if (ZF) { PC = addr; } break;
case 0xD2: addr = READ_W(PC); PC+=2; if (!CF) { PC = addr; } break;
case 0xDA: addr = READ_W(PC); PC+=2; if (CF) { PC = addr; } break;

/* JP (HL) ------------------------------------------------------------ */
case 0xE9: PC = HL; break;

/* JR n --------------------------------------------------------------- */
#define n8 signed char

#define JR(O) (unsigned short)((signed short)PC)+((n8)O)

case 0x18: lsb = READ_B(PC++); PC = JR(lsb); break;

/* JR cc, n ----------------------------------------------------------- */
case 0x20: lsb = READ_B(PC); PC+=1; if (!ZF) PC = JR(lsb); break; /* JR NZ */
case 0x28: lsb = READ_B(PC); PC+=1; if (ZF) PC = JR(lsb); break; /* JR Z */
case 0x30: lsb = READ_B(PC); PC+=1; if (!CF) PC = JR(lsb); break; /* JR NC */
case 0x38: lsb = READ_B(PC); PC+=1; if (CF) PC = JR(lsb); break; /* JR C */

/* CALL nn ------------------------------------------------------------ */
#define CALL(N) PC+=2; PUSH_B(HI(PC)); PUSH_B(LO(PC)); PC=N

case 0xCD: addr = READ_W(PC); CALL(addr); break;

/* CALL cc, nn -------------------------------------------------------- */
case 0xC4: addr = READ_W(PC);  if (!ZF) { CALL(addr); } break;
case 0xCC: addr = READ_W(PC);  if (ZF) { CALL(addr); } break;
case 0xD4: addr = READ_W(PC);  if (!CF) { CALL(addr); } break;
case 0xDC: addr = READ_W(PC);  if (CF) { CALL(addr); } break;

/* RST nn ------------------------------------------------------------- */
case 0xC7: CALL(0x00); break;
case 0xCF: CALL(0x08); break;
case 0xD7: CALL(0x10); break;
case 0xDF: CALL(0x18); break;
case 0xE7: CALL(0x20); break;
case 0xEF: CALL(0x28); break;
case 0xF7: CALL(0x30); break;
case 0xFF: CALL(0x38); break;

/* RET ----------------------------------------------------------------- */
#define RET() lsb = POP_B(); msb = POP_B(); PC = WORD(msb, lsb)

case 0xC9: RET(); break;

/* RETI ---------------------------------------------------------------- */
case 0xD9: RET(); gbcpu->ime = 1; break;

/* RET cc -------------------------------------------------------------- */
case 0xC0: if (!ZF) { RET(); } break;
case 0xC8: if (ZF) { RET(); } break;
case 0xD0: if (!CF) { RET(); } break;
case 0xD8: if (CF) { RET(); } break;

